/* Elements.c generated by valac 0.42.3, the Vala compiler
 * generated from Elements.vala, do not modify */

/*
Copyright (C) 2016 Johan Mattsson

This library is free software; you can redistribute it and/or modify 
it under the terms of the GNU Lesser General Public License as 
published by the Free Software Foundation; either version 3 of the 
License, or (at your option) any later version.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
Lesser General Public License for more details.
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define B_TYPE_ELEMENTS (b_elements_get_type ())
#define B_ELEMENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), B_TYPE_ELEMENTS, BElements))
#define B_ELEMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), B_TYPE_ELEMENTS, BElementsClass))
#define B_IS_ELEMENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), B_TYPE_ELEMENTS))
#define B_IS_ELEMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), B_TYPE_ELEMENTS))
#define B_ELEMENTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), B_TYPE_ELEMENTS, BElementsClass))

typedef struct _BElements BElements;
typedef struct _BElementsClass BElementsClass;
typedef struct _BElementsPrivate BElementsPrivate;

#define B_TYPE_XML_ELEMENT (b_xml_element_get_type ())
#define B_XML_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), B_TYPE_XML_ELEMENT, BXmlElement))
#define B_XML_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), B_TYPE_XML_ELEMENT, BXmlElementClass))
#define B_IS_XML_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), B_TYPE_XML_ELEMENT))
#define B_IS_XML_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), B_TYPE_XML_ELEMENT))
#define B_XML_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), B_TYPE_XML_ELEMENT, BXmlElementClass))

typedef struct _BXmlElement BXmlElement;
typedef struct _BXmlElementClass BXmlElementClass;
enum  {
	B_ELEMENTS_0_PROPERTY,
	B_ELEMENTS_NUM_PROPERTIES
};
static GParamSpec* b_elements_properties[B_ELEMENTS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BElements {
	GObject parent_instance;
	BElementsPrivate * priv;
	gint size;
};

struct _BElementsClass {
	GObjectClass parent_class;
};

struct _BElementsPrivate {
	BXmlElement** data;
	gint capacity;
};


static gint BElements_private_offset;
static gpointer b_elements_parent_class = NULL;

GType b_elements_get_type (void) G_GNUC_CONST;
GType b_xml_element_get_type (void) G_GNUC_CONST;
BElements* b_elements_new (void);
BElements* b_elements_construct (GType object_type);
BXmlElement* b_elements_get_element (BElements* self,
                                     gint index);
void b_xml_parser_warning (const gchar* message);
BXmlElement* b_xml_element_new_empty (void);
BXmlElement* b_xml_element_construct_empty (GType object_type);
void b_elements_add (BElements* self,
                     BXmlElement* element);
static void b_elements_finalize (GObject * obj);


static inline gpointer
b_elements_get_instance_private (BElements* self)
{
	return G_STRUCT_MEMBER_P (self, BElements_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


BElements*
b_elements_construct (GType object_type)
{
	BElements * self = NULL;
	gint _tmp0_;
	BXmlElement** _tmp1_;
	self = (BElements*) g_object_new (object_type, NULL);
	_tmp0_ = self->priv->capacity;
	_tmp1_ = g_new0 (BXmlElement*, _tmp0_);
	self->priv->data = _tmp1_;
	return self;
}


BElements*
b_elements_new (void)
{
	return b_elements_construct (B_TYPE_ELEMENTS);
}


BXmlElement*
b_elements_get_element (BElements* self,
                        gint index)
{
	BXmlElement* result = NULL;
	gboolean _tmp0_ = FALSE;
	BXmlElement** _tmp3_;
	BXmlElement* _tmp4_;
	BXmlElement* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	if (index < 0) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = self->size;
		_tmp0_ = index >= _tmp1_;
	}
	if (G_UNLIKELY (_tmp0_)) {
		BXmlElement* _tmp2_;
		b_xml_parser_warning ("Index out of bounds in Elements.");
		_tmp2_ = b_xml_element_new_empty ();
		result = _tmp2_;
		return result;
	}
	_tmp3_ = self->priv->data;
	_tmp4_ = _tmp3_[index];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	result = _tmp5_;
	return result;
}


void
b_elements_add (BElements* self,
                BXmlElement* element)
{
	gint _tmp0_;
	gint _tmp1_;
	BXmlElement** _tmp11_;
	gint _tmp12_;
	BXmlElement* _tmp13_;
	gint _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (element != NULL);
	_tmp0_ = self->size;
	_tmp1_ = self->priv->capacity;
	if (_tmp0_ >= _tmp1_) {
		gint new_capacity = 0;
		gint _tmp2_;
		BXmlElement** new_data = NULL;
		gint _tmp3_;
		BXmlElement** _tmp4_;
		BXmlElement** _tmp5_;
		BXmlElement** _tmp6_;
		gint _tmp7_;
		BXmlElement** _tmp8_;
		BXmlElement** _tmp9_;
		gint _tmp10_;
		_tmp2_ = self->priv->capacity;
		new_capacity = 2 * _tmp2_;
		_tmp3_ = new_capacity;
		_tmp4_ = g_new0 (BXmlElement*, _tmp3_);
		new_data = _tmp4_;
		_tmp5_ = new_data;
		_tmp6_ = self->priv->data;
		_tmp7_ = self->size;
		memcpy (_tmp5_, _tmp6_, (gsize) (sizeof (gdouble) * _tmp7_));
		_tmp8_ = self->priv->data;
		g_free (_tmp8_);
		_tmp9_ = new_data;
		self->priv->data = _tmp9_;
		_tmp10_ = new_capacity;
		self->priv->capacity = _tmp10_;
	}
	_tmp11_ = self->priv->data;
	_tmp12_ = self->size;
	_tmp11_[_tmp12_] = element;
	_tmp13_ = _tmp11_[_tmp12_];
	g_object_ref ((GObject*) element);
	_tmp14_ = self->size;
	self->size = _tmp14_ + 1;
}


static void
b_elements_class_init (BElementsClass * klass)
{
	b_elements_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BElements_private_offset);
	G_OBJECT_CLASS (klass)->finalize = b_elements_finalize;
}


static void
b_elements_instance_init (BElements * self)
{
	self->priv = b_elements_get_instance_private (self);
	self->size = 0;
	self->priv->capacity = 10;
}


static void
b_elements_finalize (GObject * obj)
{
	BElements * self;
	BXmlElement** _tmp9_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, B_TYPE_ELEMENTS, BElements);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				BXmlElement* e = NULL;
				BXmlElement** _tmp4_;
				gint _tmp5_;
				BXmlElement* _tmp6_;
				BXmlElement* _tmp7_;
				BXmlElement* _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->size;
				if (!(_tmp2_ < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->data;
				_tmp5_ = i;
				_tmp6_ = _tmp4_[_tmp5_];
				_tmp7_ = _g_object_ref0 (_tmp6_);
				e = _tmp7_;
				_tmp8_ = e;
				g_object_unref ((GObject*) _tmp8_);
				_g_object_unref0 (e);
			}
		}
	}
	_tmp9_ = self->priv->data;
	g_free (_tmp9_);
	self->priv->data = NULL;
	G_OBJECT_CLASS (b_elements_parent_class)->finalize (obj);
}


GType
b_elements_get_type (void)
{
	static volatile gsize b_elements_type_id__volatile = 0;
	if (g_once_init_enter (&b_elements_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BElementsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) b_elements_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BElements), 0, (GInstanceInitFunc) b_elements_instance_init, NULL };
		GType b_elements_type_id;
		b_elements_type_id = g_type_register_static (G_TYPE_OBJECT, "BElements", &g_define_type_info, 0);
		BElements_private_offset = g_type_add_instance_private (b_elements_type_id, sizeof (BElementsPrivate));
		g_once_init_leave (&b_elements_type_id__volatile, b_elements_type_id);
	}
	return b_elements_type_id__volatile;
}



