/* XmlData.c generated by valac 0.42.3, the Vala compiler
 * generated from XmlData.vala, do not modify */

/*
    Copyright (C) 2015 Johan Mattsson

    This library is free software; you can redistribute it and/or modify 
    it under the terms of the GNU Lesser General Public License as 
    published by the Free Software Foundation; either version 3 of the 
    License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful, but 
    WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
    Lesser General Public License for more details.
*/


#include <glib.h>
#include <glib-object.h>
#include <string.h>


#define B_TYPE_XML_STRING (b_xml_string_get_type ())
#define B_XML_STRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), B_TYPE_XML_STRING, BXmlString))
#define B_XML_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), B_TYPE_XML_STRING, BXmlStringClass))
#define B_IS_XML_STRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), B_TYPE_XML_STRING))
#define B_IS_XML_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), B_TYPE_XML_STRING))
#define B_XML_STRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), B_TYPE_XML_STRING, BXmlStringClass))

typedef struct _BXmlString BXmlString;
typedef struct _BXmlStringClass BXmlStringClass;
typedef struct _BXmlStringPrivate BXmlStringPrivate;

#define B_TYPE_XML_DATA (b_xml_data_get_type ())
#define B_XML_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), B_TYPE_XML_DATA, BXmlData))
#define B_XML_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), B_TYPE_XML_DATA, BXmlDataClass))
#define B_IS_XML_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), B_TYPE_XML_DATA))
#define B_IS_XML_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), B_TYPE_XML_DATA))
#define B_XML_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), B_TYPE_XML_DATA, BXmlDataClass))

typedef struct _BXmlData BXmlData;
typedef struct _BXmlDataClass BXmlDataClass;
typedef struct _BXmlDataPrivate BXmlDataPrivate;
enum  {
	B_XML_DATA_0_PROPERTY,
	B_XML_DATA_NUM_PROPERTIES
};
static GParamSpec* b_xml_data_properties[B_XML_DATA_NUM_PROPERTIES];

struct _BXmlString {
	GObject parent_instance;
	BXmlStringPrivate * priv;
	gint length;
	gchar* data;
};

struct _BXmlStringClass {
	GObjectClass parent_class;
};

struct _BXmlData {
	BXmlString parent_instance;
	BXmlDataPrivate * priv;
	gboolean error;
	gint log_level;
};

struct _BXmlDataClass {
	BXmlStringClass parent_class;
};

struct _BXmlDataPrivate {
	gint* start_tags;
	gint tags_capacity;
	gint tags_size;
};


static gint BXmlData_private_offset;
static gpointer b_xml_data_parent_class = NULL;

GType b_xml_string_get_type (void) G_GNUC_CONST;
GType b_xml_data_get_type (void) G_GNUC_CONST;
#define B_WARNINGS 1
#define B_XML_DATA_FIRST_BIT ((gchar) (1 << 7))
BXmlData* b_xml_data_new (gchar* data,
                          gint length,
                          gint log_level);
BXmlData* b_xml_data_construct (GType object_type,
                                gchar* data,
                                gint length,
                                gint log_level);
BXmlString* b_xml_string_new (gchar* data,
                              gint length);
BXmlString* b_xml_string_construct (GType object_type,
                                    gchar* data,
                                    gint length);
static void b_xml_data_index_start_tags (BXmlData* self);
gint b_xml_data_get_index (BXmlData* self,
                           BXmlString* start);
gint b_xml_data_find_next_tag_token (BXmlData* self,
                                     gint index);
static gint b_xml_data_skip_quote (BXmlData* self,
                            gchar* data,
                            gint i);
void b_xml_parser_warning (const gchar* message);
static void b_xml_data_add_tag (BXmlData* self,
                         gint index);
static gboolean b_xml_data_increase_capacity (BXmlData* self);
static void b_xml_data_finalize (GObject * obj);


static inline gpointer
b_xml_data_get_instance_private (BXmlData* self)
{
	return G_STRUCT_MEMBER_P (self, BXmlData_private_offset);
}


BXmlData*
b_xml_data_construct (GType object_type,
                      gchar* data,
                      gint length,
                      gint log_level)
{
	BXmlData * self = NULL;
	self = (BXmlData*) b_xml_string_construct (object_type, data, length);
	self->log_level = log_level;
	self->priv->start_tags = NULL;
	self->priv->tags_capacity = 0;
	self->priv->tags_size = 0;
	b_xml_data_index_start_tags (self);
	return self;
}


BXmlData*
b_xml_data_new (gchar* data,
                gint length,
                gint log_level)
{
	return b_xml_data_construct (B_TYPE_XML_DATA, data, length, log_level);
}


gint
b_xml_data_get_index (BXmlData* self,
                      BXmlString* start)
{
	gint result = 0;
	gint offset = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (start != NULL, 0);
	_tmp0_ = start->data;
	_tmp1_ = ((BXmlString*) self)->data;
	offset = (gint) (((gsize) _tmp0_) - ((gsize) _tmp1_));
	result = offset;
	return result;
}


gint
b_xml_data_find_next_tag_token (BXmlData* self,
                                gint index)
{
	gint result = 0;
	gint new_index = 0;
	gint _tmp0_;
	gint lower = 0;
	gint upper = 0;
	gint _tmp1_;
	gint i = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = ((BXmlString*) self)->length;
	if (index >= _tmp0_) {
		result = -1;
		return result;
	}
	lower = 0;
	_tmp1_ = self->priv->tags_size;
	upper = _tmp1_;
	_tmp2_ = lower;
	_tmp3_ = upper;
	_tmp4_ = lower;
	i = _tmp2_ + ((_tmp3_ - _tmp4_) / 2);
	while (TRUE) {
		gboolean _tmp5_ = FALSE;
		gint _tmp6_;
		gint _tmp23_;
		gint _tmp24_;
		gint* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		_tmp6_ = i;
		if (_tmp6_ == 0) {
			gint* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			_tmp7_ = self->priv->start_tags;
			_tmp8_ = i;
			_tmp9_ = _tmp7_[_tmp8_];
			_tmp5_ = _tmp9_ >= index;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			gint* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			_tmp10_ = self->priv->start_tags;
			_tmp11_ = i;
			_tmp12_ = _tmp10_[_tmp11_];
			new_index = _tmp12_;
			break;
		} else {
			gboolean _tmp13_ = FALSE;
			gint* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			_tmp14_ = self->priv->start_tags;
			_tmp15_ = i;
			_tmp16_ = _tmp14_[_tmp15_];
			if (_tmp16_ >= index) {
				gint* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				_tmp17_ = self->priv->start_tags;
				_tmp18_ = i;
				_tmp19_ = _tmp17_[_tmp18_ - 1];
				_tmp13_ = _tmp19_ < index;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				gint* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				_tmp20_ = self->priv->start_tags;
				_tmp21_ = i;
				_tmp22_ = _tmp20_[_tmp21_];
				new_index = _tmp22_;
				break;
			}
		}
		_tmp23_ = lower;
		_tmp24_ = upper;
		if (_tmp23_ >= _tmp24_) {
			new_index = -1;
			break;
		}
		_tmp25_ = self->priv->start_tags;
		_tmp26_ = i;
		_tmp27_ = _tmp25_[_tmp26_];
		if (_tmp27_ < index) {
			gint _tmp28_;
			_tmp28_ = i;
			lower = _tmp28_ + 1;
		} else {
			gint _tmp29_;
			_tmp29_ = i;
			upper = _tmp29_ - 1;
		}
		_tmp30_ = lower;
		_tmp31_ = upper;
		_tmp32_ = lower;
		i = _tmp30_ + ((_tmp31_ - _tmp32_) / 2);
	}
	result = new_index;
	return result;
}


static void
b_xml_data_index_start_tags (BXmlData* self)
{
	gint i = 0;
	gchar* d = NULL;
	gchar* _tmp0_;
	gchar c = '\0';
	gboolean tag_is_open = FALSE;
	gchar* _tmp1_;
	gint _tmp2_;
	gchar _tmp3_;
	g_return_if_fail (self != NULL);
	i = 0;
	_tmp0_ = ((BXmlString*) self)->data;
	d = _tmp0_;
	tag_is_open = FALSE;
	_tmp1_ = d;
	_tmp2_ = i;
	_tmp3_ = _tmp1_[_tmp2_];
	c = _tmp3_;
	while (TRUE) {
		gchar _tmp4_;
		gchar _tmp5_;
		gint _tmp16_;
		gchar* _tmp17_;
		gint _tmp18_;
		gchar _tmp19_;
		_tmp4_ = c;
		if (!(_tmp4_ != '\0')) {
			break;
		}
		_tmp5_ = c;
		if (((gint) (_tmp5_ & B_XML_DATA_FIRST_BIT)) == 0) {
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gchar _tmp13_;
			gchar _tmp15_;
			_tmp7_ = tag_is_open;
			if (_tmp7_) {
				gchar _tmp8_;
				_tmp8_ = c;
				_tmp6_ = _tmp8_ == '"';
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gchar* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				_tmp9_ = d;
				_tmp10_ = i;
				i = b_xml_data_skip_quote (self, _tmp9_, _tmp10_);
				_tmp11_ = i;
				if (G_UNLIKELY (_tmp11_ == -1)) {
					gint _tmp12_;
					_tmp12_ = self->log_level;
					if (_tmp12_ == B_WARNINGS) {
						b_xml_parser_warning ("No end quote.");
					}
					self->error = TRUE;
					break;
				}
			}
			_tmp13_ = c;
			if (_tmp13_ == '<') {
				gint _tmp14_;
				_tmp14_ = i;
				b_xml_data_add_tag (self, _tmp14_);
				tag_is_open = TRUE;
			}
			_tmp15_ = c;
			if (_tmp15_ == '>') {
				tag_is_open = FALSE;
			}
		}
		_tmp16_ = i;
		i = _tmp16_ + 1;
		_tmp17_ = d;
		_tmp18_ = i;
		_tmp19_ = _tmp17_[_tmp18_];
		c = _tmp19_;
	}
}


static gint
b_xml_data_skip_quote (BXmlData* self,
                       gchar* data,
                       gint i)
{
	gint result = 0;
	gchar c = '\0';
	gchar _tmp0_;
	gchar _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = data[i];
	c = _tmp0_;
	_tmp1_ = c;
	if (G_UNLIKELY (_tmp1_ != '"')) {
		gint _tmp2_;
		_tmp2_ = self->log_level;
		if (_tmp2_ == B_WARNINGS) {
			b_xml_parser_warning ("Not a quote.");
		}
		self->error = TRUE;
		result = i + 1;
		return result;
	}
	while (TRUE) {
		gchar _tmp3_;
		gchar _tmp4_;
		gint _tmp6_;
		gchar _tmp7_;
		_tmp3_ = c;
		if (!(_tmp3_ != '\0')) {
			break;
		}
		_tmp4_ = c;
		if (((gint) (_tmp4_ & B_XML_DATA_FIRST_BIT)) == 0) {
			gchar _tmp5_;
			_tmp5_ = c;
			if (_tmp5_ == '"') {
				result = i + 1;
				return result;
			}
		}
		_tmp6_ = i;
		i = _tmp6_ + 1;
		_tmp7_ = data[i];
		c = _tmp7_;
	}
	result = -1;
	return result;
}


static void
b_xml_data_add_tag (BXmlData* self,
                    gint index)
{
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tags_size;
	_tmp1_ = self->priv->tags_capacity;
	if (G_UNLIKELY (_tmp0_ == _tmp1_)) {
		if (!b_xml_data_increase_capacity (self)) {
			return;
		}
	}
	_tmp2_ = self->priv->start_tags;
	_tmp3_ = self->priv->tags_size;
	_tmp2_[_tmp3_] = index;
	_tmp4_ = _tmp2_[_tmp3_];
	_tmp5_ = self->priv->tags_size;
	self->priv->tags_size = _tmp5_ + 1;
}


static gboolean
b_xml_data_increase_capacity (BXmlData* self)
{
	gboolean result = FALSE;
	gint* tags = NULL;
	gint _tmp0_;
	gint _tmp1_;
	void* _tmp2_;
	gint* _tmp3_;
	gint _tmp7_;
	gint* _tmp11_;
	gint* _tmp13_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tags_capacity;
	self->priv->tags_capacity = _tmp0_ + 512;
	_tmp1_ = self->priv->tags_capacity;
	_tmp2_ = g_try_malloc ((gsize) (_tmp1_ * sizeof (gint)));
	tags = (gint*) _tmp2_;
	_tmp3_ = tags;
	if (G_UNLIKELY (_tmp3_ == NULL)) {
		gint* _tmp4_;
		gint _tmp6_;
		self->priv->tags_capacity = 0;
		_tmp4_ = self->priv->start_tags;
		if (_tmp4_ != NULL) {
			gint* _tmp5_;
			_tmp5_ = self->priv->start_tags;
			g_free (_tmp5_);
			self->priv->start_tags = NULL;
			self->priv->tags_size = 0;
			self->error = TRUE;
		}
		_tmp6_ = self->log_level;
		if (_tmp6_ == B_WARNINGS) {
			b_xml_parser_warning ("Can not allocate xml data buffer.");
		}
		result = FALSE;
		return result;
	}
	_tmp7_ = self->priv->tags_size;
	if (_tmp7_ > 0) {
		gint* _tmp8_;
		gint* _tmp9_;
		gint _tmp10_;
		_tmp8_ = tags;
		_tmp9_ = self->priv->start_tags;
		_tmp10_ = self->priv->tags_size;
		memcpy (_tmp8_, _tmp9_, (gsize) (_tmp10_ * sizeof (gint)));
	}
	_tmp11_ = self->priv->start_tags;
	if (_tmp11_ != NULL) {
		gint* _tmp12_;
		_tmp12_ = self->priv->start_tags;
		g_free (_tmp12_);
	}
	_tmp13_ = tags;
	self->priv->start_tags = _tmp13_;
	result = TRUE;
	return result;
}


static void
b_xml_data_class_init (BXmlDataClass * klass)
{
	b_xml_data_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BXmlData_private_offset);
	G_OBJECT_CLASS (klass)->finalize = b_xml_data_finalize;
}


static void
b_xml_data_instance_init (BXmlData * self)
{
	self->priv = b_xml_data_get_instance_private (self);
	self->error = FALSE;
	self->log_level = B_WARNINGS;
}


static void
b_xml_data_finalize (GObject * obj)
{
	BXmlData * self;
	gint* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, B_TYPE_XML_DATA, BXmlData);
	_tmp0_ = self->priv->start_tags;
	if (_tmp0_ != NULL) {
		gint* _tmp1_;
		_tmp1_ = self->priv->start_tags;
		g_free (_tmp1_);
		self->priv->start_tags = NULL;
	}
	G_OBJECT_CLASS (b_xml_data_parent_class)->finalize (obj);
}


GType
b_xml_data_get_type (void)
{
	static volatile gsize b_xml_data_type_id__volatile = 0;
	if (g_once_init_enter (&b_xml_data_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BXmlDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) b_xml_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BXmlData), 0, (GInstanceInitFunc) b_xml_data_instance_init, NULL };
		GType b_xml_data_type_id;
		b_xml_data_type_id = g_type_register_static (B_TYPE_XML_STRING, "BXmlData", &g_define_type_info, 0);
		BXmlData_private_offset = g_type_add_instance_private (b_xml_data_type_id, sizeof (BXmlDataPrivate));
		g_once_init_leave (&b_xml_data_type_id__volatile, b_xml_data_type_id);
	}
	return b_xml_data_type_id__volatile;
}



